: <<editor.f>> ;
( editors is managed by a circular single link list,
  GWL_USERDATA stores the link field )

VARIABLE hFile
VARIABLE ReadByte
VARIABLE WriteByte

VARIABLE LINE#
VARIABLE NONAMECOUNTER 1 NONAMECOUNTER !
VARIABLE STATUSBAR 
VARIABLE THISEDIT       \ handle to focal edit control
VARIABLE THISEDITOR     \ handle of focal editor window
VARIABLE LASTEDITOR     \ handle of newly created editor
CREATE FILENAME $100 ALLOT   
CREATE FILENAMEFILTER $," orth Files (*.F)"  $," .f" $," ll Files (*.*)" $," .*" 0 C, 
$46 FILENAMEFILTER C!
$2A FILENAMEFILTER $12 + C!   \ this is a hack
$41 FILENAMEFILTER $16 + C!
$2A FILENAMEFILTER $26 + C!

$1000 CONSTANT OFN_FILEMUSTEXIST         
$800 CONSTANT OFN_PATHMUSTEXIST   

CREATE EDITOR_SBPARTS $40 , $80 , $F0 , $12A , -1 ,
CREATE OPENFILENAME 
$4C ,                                         \ lStructSize; 
0 ,                                           \ hwndOwner; 
HINST @ ,                                     \ hInstance; 
FILENAMEFILTER ,                              \ lpstrFilter; 
0 ,                                           \ lpstrCustomFilter; 
0 ,                                           \ nMaxCustFilter; 
0 ,                                           \ nFilterIndex; 
FILENAME ,                                    \ lpstrFile   
$FF ,                                         \ nMaxFile; 
0 ,                                           \ lpstrFileTitle; 
0 ,                                           \ nMaxFileTitle; 
0 ,                                           \ lpstrInitialDir; 
0 ,                                           \ lpstrTitle; 
OFN_FILEMUSTEXIST OFN_PATHMUSTEXIST OR ,      \ Flags; 
0 ,                                           \ nFileOffset nFileExtension 
0 ,                                           \ lpstrDefExt; 
0 ,                                           \ lCustData; 
0 ,                                           \ lpfnHook; 
0 ,                                           \ lpTemplateName;



VARIABLE DefEditProc

: thisedit.action ( usg wparam lparam -- res )
  >R >R >R DefEditProc @ THISEDIT @ R> R> R> CallWindowProcA 
;

: LINEBUFFER
  PAD $800 +
;
: FILEBUFFER
  PAD $1000 +
;
: FILEBUFFERLEN
  $20000    \ 128K
;
: CLOSEFILE ( hFile -- )
  CloseHandle DROP
;  
: EDITORFILENAME ( hWnd -- )  \ get editing file name into FILENAME
  &DefWindowProcA SWAP WM_GETTEXT $FF FILENAME CallWindowProcA DROP
;

: ?MODIFIED ( hEdit -- )            \ return true if file is modified
  DefEditProc @ SWAP EM_GETMODIFY 0 0 CallWindowProcA 
;

: CREATEFILE ( zfilename flag -- hFile )
  >R
  GENERIC_READ GENERIC_WRITE OR 
  FILE_SHARE_READ
  0
  R>
  FILE_ATTRIBUTE_ARCHIVE
  0 
  CreateFileA 
;

: OPENFILE  ( cfilename -- hFile ) \ return handle, full filename in FILENAME
  DUP C@ 0 = IF
    DROP
    FILENAME $100 0 FILL
    
    OPENFILENAME GetOpenFileNameA IF
      FILENAME
    ELSE
      NONAMECOUNTER @ <# #S $74 HOLD $69 HOLD $64 HOLD $45 HOLD #> DROP
      1 NONAMECOUNTER +!
    THEN
  ELSE
    1+  \ skip count byte
  THEN
  $100 FILENAME 0 GetFullPathNameA DROP    \ expand to full fillname
  
  FILENAME                                 \ skip count byte
  OPEN_EXISTING
  CREATEFILE
;

: WRITEFILE ( hFile -- )
  FILEBUFFER  ( hFile Buffer )
  WM_GETTEXT FILEBUFFERLEN FILEBUFFER thisedit.action
  WriteByte
  0
  WriteFile IF
    THISEDIT @ EM_SETMODIFY 0 0 SendMessageA DROP
    &DefWindowProcA THISEDITOR @ WM_SETTEXT 0 FILENAME  CallWindowProcA DROP
  ELSE
    ." Error writing file"
  THEN
;

: SAVEFILEAS ( -- )
  THISEDITOR @ EDITORFILENAME        \ get editor filename on caption
  THISEDITOR @ OPENFILENAME CELL+ !  \ set owner to this window
  OPENFILENAME GetSaveFileNameA IF
    &DefWindowProcA THISEDITOR @ WM_SETTEXT 0 FILENAME CallWindowProcA DROP
    FILENAME  CREATE_ALWAYS
 CREATEFILE hFile !
    hFile @ WRITEFILE 
    hFile @ CloseHandle DROP
  THEN
  hConsole @ OPENFILENAME CELL+ !  \ set owner to console window

;

: SAVEFILE
  THISEDITOR @ EDITORFILENAME FILENAME TRUNCATE_EXISTING CREATEFILE hFile !
  hFile @ -1 =                  \ file not exist
  IF 
    SAVEFILEAS
  ELSE 
    hFile @ WRITEFILE 
    hFile @ CloseHandle DROP
  THEN
;

: QUITFILE
  THISEDITOR @ WM_CLOSE 0 0 SendMessageA DROP
;

: MAKEINVISIBLE ( hWnd --)
  GWL_STYLE 2DUP
  GetWindowLongA WS_VISIBLE NOT AND
  SetWindowLongA DROP
;

: MAKEVISIBLE ( hWnd --)
  GWL_STYLE 2DUP
  GetWindowLongA WS_VISIBLE OR
  SetWindowLongA DROP
;
  
: INSERTSTRING ( zbuf -- )  \ insert null terminate string into edit control
  >R
  THISEDIT @ WM_GETTEXTLENGTH 0 0 SendMessageA >R  
  THISEDIT @ EM_SETSEL     R> DUP SendMessageA DROP
  THISEDIT @ EM_REPLACESEL 0  R>  SendMessageA DROP
;

\ read from PAD+$100

: READTOEDIT  ( hFile -- )
  hFile !
  THISEDIT @ MAKEINVISIBLE
  BEGIN                         
      hFile @ PAD $100 + FREESPACE $2000 - ReadByte 0 ReadFile DROP
      0 PAD $100 + ReadByte @ + !        \ store null terminator
      PAD $100 + INSERTSTRING
  ReadByte @ 0 =  UNTIL
  THISEDIT @ EM_SETSEL 0 0 SendMessageA DROP
  THISEDIT @ EM_SCROLLCARET 0 0 SendMessageA DROP
  THISEDIT @ EM_SETMODIFY 0 0 SendMessageA  DROP
  THISEDIT @ MAKEVISIBLE
;


: RUNFILE
  FILEBUFFER 
  WM_GETTEXT FILEBUFFERLEN FILEBUFFER thisedit.action BLOAD
;
VARIABLE SelStart
VARIABLE SelEnd

: SELECTLINE 
  EM_LINEFROMCHAR -1 0 thisedit.action >R
  
  EM_GETSEL SelStart 0 thisedit.action DROP
  
  EM_SETSEL
  EM_LINEINDEX R> 0 thisedit.action
  EM_LINELENGTH SelStart @ 0 thisedit.action OVER +
  thisedit.action
;

: COPYLINE ( terminator -- )
\  SELECTLINE 
  >R
  $FF CLIPBUF C!   \ set the length of linebuffer to $FF
  EM_GETLINE
  EM_LINEFROMCHAR -1 0 thisedit.action
  CLIPBUF thisedit.action 
  CLIPBUF + R> SWAP ! \ null terminator
  
  1 CLIPBOARD>IN !
;

: RUNLINE
  $D COPYLINE
;

: FLOADFILE
  THISEDITOR @ EDITORFILENAME FILENAME doFLOAD
;

: TOCONSOLE
 hConsole @ SetFocus DROP
;

: SWITCHWINDOW  ( hWnd -- )         \ SetFocus to hWnd
  EDITID GetDlgItem SetFocus DROP
;

: PREVFILE ( -- )
  THISEDIT @ GetParent >LINK 
  SWITCHWINDOW 
;

: NEXTFILE ( -- )
  THISEDIT @ GetParent LINK> SWITCHWINDOW 

;

 
: UPDATEFILESTATUS ( hStatusBar -- )
  STATUSBAR !
  BASE @ >R $A BASE !
\ Line :

  EM_LINEFROMCHAR -1 0 thisedit.action  LINE# ! 
  STATUSBAR @ SB_SETTEXT 0 LINE# @ 1+ <# #S $20  HOLD $6E  HOLD $4C HOLD #> DROP SendMessageA DROP  
  
  EM_GETSEL SelStart 0 thisedit.action DROP
  SelStart @ 
  EM_LINEINDEX LINE# @ 0 thisedit.action
  - 1+ >R
  STATUSBAR @ SB_SETTEXT 1 R> <# #S $20 HOLD $6C HOLD $6F HOLD  $43 HOLD #> DROP SendMessageA DROP
  
\ File Size:
  WM_GETTEXTLENGTH 0 0 thisedit.action >R
  STATUSBAR @ SB_SETTEXT 2  R> 
   <# #S $20 HOLD $65 HOLD $7A HOLD $69 HOLD $53 HOLD #> DROP 
  SendMessageA DROP

\ Modified flag

  EM_GETMODIFY 0 0 thisedit.action
  IF Z" Modified" ELSE Z" Saved" THEN >R
  STATUSBAR @ SB_SETTEXT 3 R> SendMessageA DROP
    
  R> BASE !
;

: EDITAREAPROC ( hWnd uMsg wParam lParam -- res )
  GETMSGWLPARAM  THISEDIT !
  uMsg @ WM_KEYUP = IF
    $71 wParam @ = IF SAVEFILE THEN     \ F2
    $72 wParam @ = IF SAVEFILEAS THEN   \ F3
    $73 wParam @ = IF QUITFILE THEN     \ F4
    $74 wParam @ = IF 0 COPYLINE TOCONSOLE THEN  \ F5
    $75 wParam @ = IF RUNLINE   THEN  \ F6
    $76 wParam @ = IF RUNFILE THEN    \ F7
    $77 wParam @ = IF FLOADFILE THEN    \ F8
    $78 wParam @ = IF TOCONSOLE THEN    \ F9
    $7A wParam @ = IF PREVFILE THEN     \ F11
    $7B wParam @ = IF NEXTFILE THEN     \ F12
  THEN
  
  uMsg @ wParam @ lParam @ thisedit.action 
  THISEDIT @ GetParent STATUSBARID GetDlgItem UPDATEFILESTATUS
  
;


: EDITORPROC ( hWnd uMsg wParam lParam -- res )
  GETMSGWLPARAM THISEDITOR !
  THISEDITOR @ EDITID GetDlgItem THISEDIT !
  
  uMsg @ WM_SIZE = IF
    THISEDITOR @ RECT GetClientRect DROP
    THISEDITOR @ STATUSBARID GetDlgItem STATUSBAR ! 
    STATUSBAR @ 0 RECT.BOTTOM @ $14 - RECT.RIGHT @ RECT.BOTTOM @ -1 MoveWindow DROP
    STATUSBAR @ SB_SETPARTS 5 EDITOR_SBPARTS SendMessageA DROP
    STATUSBAR @ SB_SETTEXT 4 Z" F2:Save F3:SaveAs F4:Quit F5:CopyLine F6:RunLine F7:RunFile F8:FLOAD F9:Console F11:Prev F12:Next" SendMessageA DROP
    THISEDIT @ 0 0 RECT.RIGHT @ RECT.BOTTOM @ $1B - -1 MoveWindow DROP
    STATUSBAR @ UPDATEFILESTATUS
  THEN 
  
  uMsg @ WM_ACTIVATE = IF
    THISEDITOR @ EDITID GetDlgItem SetFocus DROP
  THEN
  
  uMsg @ WM_CLOSE = IF
    THISEDIT @ ?MODIFIED IF
      THISEDITOR @ Z" Save changes before quit?" Z" WeEditor" MB_YESNOCANCEL MB_ICONEXCLAMATION OR MessageBoxA
      DUP IDCANCEL = IF DROP EXIT THEN
      IDYES = IF SAVEFILE THEN
    THEN
    THISEDITOR @ DestroyWindow DROP
    
  THEN
  
  
   uMsg @ WM_DESTROY = IF
     THISEDITOR @ REMOVEFROMLINK
   THEN
  
  THISEDITOR @ uMsg @ wParam @ lParam @ DefWindowProcA 
;

' EDITAREAPROC MESSAGEHANDLER: &EDITAREAPROC
' EDITORPROC MESSAGEHANDLER: &EDITORPROC

: EDITORONCREATE ( -- )
  0 
  Z" EDIT"
  0
  $50200104     \ WS_CHILD+WS_VISIBLE+WS_VSCROLL+ES_NOHIDESEL+ES_MULTILINE
  CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT
  THISEDITOR @
  EDITID
  HINST @
  0
  CreateWindowExA THISEDIT !
  
  
  THISEDIT @ GWL_WNDPROC &EDITAREAPROC SetWindowLongA DefEditProc !
  THISEDIT @ SetFocus DROP
  THISEDIT @ WM_SETFONT SYSTEM_FIXED_FONT GetStockObject 0 SendMessageA DROP


  0
  Z" msctls_statusbar32"
  0
  $50800010
  CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT
  THISEDITOR @
  STATUSBARID
  HINST @
  0
  CreateWindowExA DROP
  
;


: EDITFILE ( cfilename -- )
  OPENFILE hFile !
  \ see if the file is open in another window
  FORMCLASSNAMEA FILENAME FindWindowA ?DUP IF
    SetActiveWindow DROP                   \ switch to the window 
    hFile @ CloseHandle DROP               \ instead of open a new one
    EXIT
  THEN
  
  0 
  FORMCLASSNAMEA 
  FILENAME                                 \ filename  as caption
  $10CF0180
  CW_USEDEFAULT CW_USEDEFAULT 380 200   \ 50 50 300 150
  0
  0
  HINST @
  0
  CreateWindowExA THISEDITOR !
  THISEDITOR @ LASTEDITOR INSERTTOLINK
  EDITORONCREATE
  THISEDITOR @ GWL_WNDPROC &EDITORPROC SetWindowLongA DROP
  THISEDITOR @ WM_SIZE 0 0 SendMessageA DROP
  

  hFile @ -1 = IF ELSE
    hFile @ DUP READTOEDIT CloseHandle DROP
  THEN
;  

: EDIT  ( -filename- )                    \ open an editor window
  FILENAME $100 0 FILL
  BL WORD
  EDITFILE
;


