anew <<hf0meta.f>>

cr
FLOAD HF1INIT.F

\ Copyright (c) 2002 by Wuja
\ All rights reserved 
\
\ HEMETA.F   06MAY02 created by Wuja.
\
\ HenceForth MetaCompiler.
\
\ (Rewrited from ARM7eForth V1.0 MetaCompiler)
\
\ Description:
\     This is my first time to port Dr. Ting's eForth system to the Win32 environment.
\   It is also my first time to have so much interest in the MS Windows programming.
\   Before this, of couse, I have some knowledge about how to program a Widowns program.
\   But I didn't have any idea to connect the two world between the Forth and the Windows.
\   Thank Yap's WeForth for giving me so perfect experience about eForth's first step in 
\   the Windows. Based on it, then I can get enough encouragement to try my first step. 
\
\ Version Hsiroty: 
\ V0.0,    23OTC01WUJA,  Adapted from WIN32FOR V4.2 MetaCompiler.
\ V0.1,    05MAY02WUJA,  o Rewrited from ARM7eForth V1.0 MetaCompiler.
\                        o A subroutine thread code architecture.
\                        o The created PE file is a console mode windows application.
\                        o The essential APIs used are: _kbhit(), _getch(), _putch(), _exit()
\                          from MSVCRT.DLL and MessageBox() from USER32.DLL . 
\ V0.2,    18MAY02WUJA,  o Add APIs: LoadLibrary() and GetProcAddress() from KERNEL32.DLL . 
\                        o Remove API: MessageBox() .
\                        o Let basic I/O defitions are as "DEFER" words and patched when Metacompiling
\                          is finished.      
\ V0.3,    21MAY02WUJA,  o Remove APIs: _kbhit(), _getch(), _putch(), _exit() .
\                        o The created PE file is a graphic mode windows application.
\ V0.4,    04JUN02WUJA,  o Add ICON data.
\
\
\                 HenceForth Memory Allocation
\ ---------------------------------------------------------------------------
\ 
\ 
\                       +------------------------+  
\                       |      Free Space        |
\                       |   (Default 256 bytes)  |
\                       |------------------------|
\                       |                        |
\                       |       Dictionary       |
\                       |                        |
\            DICT_BASE  +------------------------+  $00401600
\                       |   System Initial Area  |
\            INIT_BASE  +------------------------+  $00401500
\                       |   User Variable Area   |
\                  UPP  +------------------------+  $00401410
\                       |       Reserved         |
\                  SPP  +------------------------+  $00401400
\                       |   Default Data Stack   |
\                       +------------------------+  $00401300
\                       |  Terminal Input Buffer |
\  MININT,MEM_BASE,TIB  +------------------------+  $00401200
\                       |      Windows Stuff     |
\                       +------------------------+  $00401000
\                       |    ***None-Used***     |
\                       +------------------------+  $00400200
\                       |       PE Header        |
\                       +------------------------+  $00400040
\                       |       DOS Stub         |
\               PE_BASE +------------------------+  $00400000
\                       

( Metacompiling initialization )
\ EMPTY
HEX
\ SYS-WARNING-OFF
\ WARNING OFF
\ ' NOOP IS STACK-CHECK

( Define words in FORTH for vocanulary operations )
VOCABULARY META
VOCABULARY TARGET
VOCABULARY FORWARD
VOCABULARY TRANSITION

' FORWARD VCFA>VOC CONSTANT FORWARD-WORDLIST
' TARGET  VCFA>VOC CONSTANT TARGET-WORDLIST

: IN-FORTH ( -- ) ONLY new ALSO META ALSO FORTH ;
: IN-META ( -- ) ONLY new ALSO META ALSO DEFINITIONS ;
: IN-TRANSITION ( -- ) ONLY new also FORWARD ALSO TARGET ALSO TRANSITION ;
: IN-ASSEMBLER ( -- ) ONLY new ALSO ASSEMBLER DEFINITIONS ;

8000 CONSTANT IMAGE_SIZE

CREATE IMAGE  IMAGE_SIZE ALLOT
IMAGE IMAGE_SIZE ERASE

( Define words in META for metacompiling )
IN-META

( Memory Constants )
$00400000 CONSTANT      PE_BASE           	\ bottom of loaded PE file 
$00401200 CONSTANT      MININT                 	\ bottom of HenceForth memory map
MININT IMAGE_SIZE + 1 - 
          CONSTANT      MAXINT                 	\ top of HenceForth memory map
$4    	  CONSTANT      CELL_SIZE              	\ size of one cell
$100      CONSTANT      TIB_SIZE               	\ TIB size
$100      CONSTANT      USER_SIZE              	\ user area size in cells
$100      CONSTANT      DS_SIZE                	\ data stack size
$500      CONSTANT      INIT_SIZE              	\ initialization area size
$100      CONSTANT      FREE_SIZE

MININT    CONSTANT 	MEM_BASE              	\ base of memory
MININT    CONSTANT 	=TIB                   	\ base of T.I.B (TIB)
=TIB TIB_SIZE + DS_SIZE +
          CONSTANT	=SPP 		     	\ bottom of data stack (SP0)	
=SPP $10 + 
          CONSTANT 	=UPP                   	\ base of eforth user area
=UPP USER_SIZE + $10 -
          CONSTANT 	INIT_BASE               \ base of system initial area
INIT_BASE INIT_SIZE +          
          CONSTANT 	DICT_BASE               \ bottom of dictionary

VARIABLE ENTRY_POINT				\ entry point holder of PE	

( Misc. Constant )
$0A       CONSTANT      =BASEE
$E8       CONSTANT 	=CALL


( eForth Builder Variabler )
VARIABLE LINKK  0 LINKK !                      \ initial link pointer

( Memory access words )
VARIABLE CP-T    
DICT_BASE CP-T !                               \ initialize target code dictionary point

: ORG     ( taddr -- )       CP-T !   ;

: THERE   ( taddr -- addr )  MEM_BASE - IMAGE +  ;
: C@-T    ( taddr -- c )     THERE C@ ;
: W@-T    ( taddr -- w )     THERE w@ ;
: @-T     ( taddr -- n )     THERE @  ;
: C!-T    ( c taddr -- )     THERE C! ;
: W!-T    ( w taddr -- )     THERE w! ;
: !-T     ( n taddr -- )     THERE !  ;
: HERE-T  ( -- taddr )       CP-T @   ;
: ALLOT-T ( n -- )           CP-T +!  ;
: C,-T    ( c -- )           HERE-T C!-T 1 CP-T +! ;
: W,-T    ( w -- )           DUP C,-T $FF /  C,-T  ;
: ,-T     ( n -- )           HERE-T !-T 4 CP-T +!  ;
: S,-T    ( addr len -- )    0 ?DO COUNT C,-T LOOP DROP ;
: ALIGN-T ( -- )             HERE-T ALIGNED HERE-T - ALLOT-T ;
: '-T     ( -- a )           ' ;

( Modify assembler to place code into target )

' HERE-T     ASSEMBLER ASM-HIDDEN IS CODE-HERE    META
' C,-T       ASSEMBLER ASM-HIDDEN IS CODE-C,      META
' W,-T       ASSEMBLER ASM-HIDDEN IS CODE-W,      META
' ,-T        ASSEMBLER ASM-HIDDEN IS CODE-D,      META
' C@-T       ASSEMBLER ASM-HIDDEN IS CODE-C@      META
' C!-T       ASSEMBLER ASM-HIDDEN IS CODE-C!      META
' W@-T       ASSEMBLER ASM-HIDDEN IS CODE-W@      META
' W!-T       ASSEMBLER ASM-HIDDEN IS CODE-W!      META
'  @-T       ASSEMBLER ASM-HIDDEN IS CODE-D@      META
'  !-T       ASSEMBLER ASM-HIDDEN IS CODE-D!      META

( ASSEMBLER MACROS )
: MACRO  ASSEMBLER DEFINITIONS : ;
: END-MACRO   POSTPONE ; META DEFINITIONS ; IMMEDIATE

ASSEMBLER DEFINITIONS
( eForth VM Register Definition )
' ebx 		ALIAS TOP
' [ebx]		ALIAS [TOP]
' ebx, 		ALIAS TOP,
' [ebx],	ALIAS [TOP],
' ebp		ALIAS SP
' [ebp]         ALIAS [SP]
' ebp,		ALIAS SP,
' [ebp],        ALIAS [SP],
' esp		ALIAS RP
' [esp]		ALIAS [RP]
' esp,		ALIAS RP,
' [esp],	ALIAS [RP],
' eax           ALIAS WP
' [eax]         ALIAS [WP]
' eax,          ALIAS WP,
' [eax],        ALIAS [WP],
' al            ALIAS WPL
' al,           ALIAS WPL,
' ecx           ALIAS XP
' [ecx]         ALIAS [XP]
' ecx,          ALIAS XP,
' [ecx],        ALIAS [XP],
' edx           ALIAS YP
' [edx]         ALIAS [YP]
' edx,          ALIAS YP,
' [edx],        ALIAS [YP],

( Windows API Constants )
$00401038 CONSTANT	LoadLibraryA
$0040103C CONSTANT	GetProcAddress


( Alias Word )
: C, [ ASSEMBLER ] [ ASM-HIDDEN ] CODE-C, ; ASSEMBLER

.head
IN-META

( Define meta branching constructs )
: ?CONDITION TRUE - ABORT" Conditionals not paired" ;

: ?>MARK    ( -- f addr ) TRUE HERE-T 0 ,-T ;                  \ forward reference
: ?>RESOLVE ( f addr -- ) HERE-T SWAP !-T ?CONDITION ;         \ resolve forward reference
: ?<MARK    ( -- f addr ) TRUE HERE-T ;                        \ back reference
: ?<RESOLVE ( f addr -- ) ,-T ?CONDITION ;                     \ resolve backward reference

( Meta compiler forward reference linking )
VARIABLE FORWARD-LINK    0 FORWARD-LINK !

: CALL,  ( taddr -- ) 
  =CALL C,-T HERE-T CELL+ - ,-T ;          	\ call to taddr

: MAKE-CODE ( pfa -- )  
  @ CALL, ;					\ subroutine thread code 				
    
: LINK-BACKWARDS ( pfa -- )
    HERE-T OVER @ ,-T SWAP ! ;
: RESOLVED? ( pfa -- f )
    CELL+ @ ;
    
: DO-FORWARD ( -- )
    DOES> 
      DUP RESOLVED?
        IF MAKE-CODE
        ELSE LINK-BACKWARDS 
        THEN
    ;
    
: (FORWARD)  ( taddr -- )
    GET-CURRENT >R
    FORWARD-WORDLIST SET-CURRENT
    CREATE
      ,  ( taddr )
      FALSE , ( resolve flag )
      HERE FORWARD-LINK @ , FORWARD-LINK !
    DO-FORWARD
    R> SET-CURRENT ;

: FORWARD: ( -- )
    0 (FORWARD) ;
    
: UNDEFINED ( -- )
    HERE-T (FORWARD) 0 ,-T ;

( Compile a code definition header )
VARIABLE LAST-T     0 LAST-T !
VARIABLE NP-T                                   
MEM_BASE NP-T !                          \ initialize target name dictionary point

: .WORD ( taddr -- )
  . SPACE >IN @ BL WORD COUNT TYPE >IN ! CR  ;

: HEADER ( -- )
  HERE-T .WORD                          \ display cfa   
                                        \ LFA 
                                        \ LEX 
                                        \ STRING 
  LAST-T DUP @ ,-T                      \ LFA 
  HERE-T SWAP !                         \ reset link point to a current name string
  BL WORD COUNT DUP C,-T                \ default LEX+LENGTH
  S,-T                                  \ fill string
  ( 0 C,-T )				\ 0-terminated
  ;
  
( Meta compiler create target image )
VARIABLE TARGET-LINK
0 TARGET-LINK !
   
: DO-TARGET  DOES> MAKE-CODE ;

: TARGET-CREATE ( -- )
  >IN @ HEADER >IN !
  TARGET DEFINITIONS
  CREATE
    HERE-T ,
    HERE TARGET-LINK @ , TARGET-LINK !
  DO-TARGET
  META DEFINITIONS ;
     
: RECREATE  ( -- )
  >IN @  TARGET-CREATE >IN ! ;
  
( Create target code words )

: HAVE ( -- f ) DEFINED NIP 0<> ;

HAVE CLEAR-LABELS 0= [IF]
: CLEAR-LABELS ;
: CHECK-LABELS ;
[THEN]

: INIT-ASSEMBLER  ( -- )        \ prepare for assembly code
        [ ASSEMBLER ] CLEAR-LABELS [ ASM-HIDDEN ] RESET-ASM [ META ]
        ASSEMBLER DEFINITIONS  !CSP ;

: CODE  ( -- )
   TARGET-CREATE INIT-ASSEMBLER ;
 
: LABEL   ( -- )
   INIT-ASSEMBLER  HERE-T CONSTANT  ;
 
ASSEMBLER DEFINITIONS
: END-CODE   A;  IN-META
      [ ASM-HIDDEN ]  ?FINISHED ?UNRES  [ ASSEMBLER ]  ?CSP  ;
: C;   END-CODE  ;
META DEFINITIONS

: FIND&EXECUTE  ( addr len wordlist -- ? )
        SEARCH-WORDLIST 0= ABORT" Target word not found"  EXECUTE ;

: DEFERED  ( wordlist -- )
        BL WORD COUNT POSTPONE SLITERAL
        POSTPONE LITERAL
        POSTPONE FIND&EXECUTE ;

: [TARGET]  ( -- )  TARGET-WORDLIST    DEFERED ; IMMEDIATE
 
( Find the next word in a single wordlist only )
: DEFINED-IN  ( -- xt )
        ' ( BL WORD COUNT ROT SEARCH-WORDLIST  0= ?MISSING ) ;

: 'T   ( -- xt )   ONLY ALSO TARGET DEFINED-IN ONLY FORTH ALSO META ALSO ;
: 'F   ( -- xt )   ONLY ALSO FORWARD DEFINED-IN ONLY FORTH ALSO META ALSO ;

: [FORWARD]   ( -- )    'F COMPILE, ;   IMMEDIATE

( Define transition words, which behave like forth immediate words )

: T:   TRANSITION DEFINITIONS  META  :  ;
: T;   [COMPILE] ;  META DEFINITIONS ; IMMEDIATE

: [TRANSITION]  ONLY ALSO TRANSITION DEFINED-IN COMPILE, ONLY FORTH ALSO META ALSO ; IMMEDIATE

T: (   [COMPILE] (   T;
T: \   [COMPILE] \   T;

: STRING,-T  [CHAR] " PARSE  DUP C,-T  S,-T ;

FORWARD: <(.")>

T: ."   =CALL C,-T  [FORWARD]  <(.")>   STRING,-T   T;

\ FORWARD: <(S")>
\ T: S"    [FORWARD] <(S")>   STRING,-T   T;

FORWARD: <(ABORT")>
T: ABORT"  =CALL C,-T [FORWARD] <(ABORT")>    STRING,-T   T;

( Define target vocabularies uh, wordlists )

VARIABLE VOC-LINK-T
FORWARD: <VOCABULARY>

: VOCABULARY   ( -- )
        TARGET-CREATE
        =CALL C,-T [FORWARD] <VOCABULARY>
        0 ,-T
        HERE-T  VOC-LINK-T @ ,-T   VOC-LINK-T ! 
        ;

$80       CONSTANT =IMMEDIATE
$40       CONSTANT =COMPILE-ONLY
$7F7F7F1F CONSTANT =MASK


: IMMEDIATE   ( -- )
        LAST-T @  DUP C@-T =IMMEDIATE OR  ( Precedence Bit )  SWAP C!-T ;
  
: COMPILE-ONLY ( -- )
        LAST-T @  DUP C@-T =COMPILE-ONLY OR  ( compiler-only Bit )  SWAP C!-T ;

VARIABLE STATE-T

T: [COMPILE]   'T EXECUTE    T;

: >BODY-T  4 + ;

\ FORWARD: <(IS)>
\ T: IS      [FORWARD] <(IS)>    T;
\ :  IS    'T >BODY @ >BODY-T  2DUP !-T  8 + !-T ;
\  ( patches both current and default value of defered word )

( Meta Compiler Resolve Forward References )

0 VALUE #UNRESOLVED

: .UNRESOLVED   ( -- )
        0 TO #UNRESOLVED
        FORWARD-LINK
        BEGIN   @ DUP
        WHILE   DUP 2 CELLS - RESOLVED? 0=
                IF      DUP 2 CELLS - BODY> .NAME  ( *SYSDEP* )
                        1 +TO #UNRESOLVED
                THEN
                START/STOP
        REPEAT  DROP
        #UNRESOLVED
        IF      CR ." !!!!!! There were: " #UNRESOLVED . ." words Unresolved !!!!!!"
                3 0 DO BEEP 300 MS LOOP
        ELSE    CR ." *** No words Unresolved ***"
        THEN    ;

: FIND-UNRESOLVED   ( -- cfa f )
        'F    DUP  >BODY RESOLVED?     ;

: RESOLVE   ( taddr cfa -- )
        >BODY   2DUP TRUE OVER CELL+ !  @
        BEGIN   DUP
        WHILE   2DUP @-T -ROT OVER CELL+ - SWAP !-T
        REPEAT  2DROP  !   ;

: RESOLVES   ( taddr -- )
        FIND-UNRESOLVED
        IF      .NAME ." Already Resolved"   DROP  ( *SYSDEP* )
        ELSE    RESOLVE
        THEN   ;

( Meta compiler Branching & Looping )

T: IF      [TARGET] ?BRANCH  ?>MARK   T;

T: THEN                      ?>RESOLVE    T;
T: ELSE    [TARGET] BRANCH   ?>MARK   2SWAP ?>RESOLVE   T;

T: BEGIN                     ?<MARK   T;
T: AGAIN   [TARGET] BRANCH   ?<RESOLVE   T;
T: UNTIL   [TARGET] ?BRANCH  ?<RESOLVE   T;
T: WHILE   [TARGET] ?BRANCH  ?>MARK  2SWAP  T;
T: REPEAT  [TARGET] BRANCH   ?<RESOLVE  ?>RESOLVE   T;

T: FOR     [TARGET] >R       ?<MARK   T;
T: NEXT    [TARGET] _next    ?<RESOLVE T;
T: AFT     [TARGET] BRANCH   2DROP ?>MARK  ?<MARK 2SWAP T;      

T: ?DO     [TARGET] (?DO)    ?>MARK   T;
T: DO      [TARGET] (DO)     ?>MARK   T;
T: LOOP    [TARGET] (LOOP)   2DUP CELL+   ?<RESOLVE   ?>RESOLVE   T;
T: +LOOP   [TARGET] (+LOOP)  2DUP CELL+   ?<RESOLVE   ?>RESOLVE   T;

( Meta compiler literals )
T: LITERAL   ( n -- )   [TARGET] DOLIT  ,-T T;
T: [CHAR]    ( -- )     CHAR        [TRANSITION] LITERAL   T;
T: [']       ( -- )     'T >BODY @  [TRANSITION] LITERAL   T;

( Meta compiler defining words )

: USER  ( n -- )        
        RECREATE  [TARGET] DOUSER 
        DUP ,-T   CONSTANT   ;

: CREATE  ( -- )
        RECREATE  [TARGET] DOVAR 
        HERE-T CONSTANT  ;

: VARIABLE  ( -- )
        CREATE   0 ,-T   ;

: CONSTANT   ( n -- )
        RECREATE  [TARGET] DOCON 
        DUP ,-T   CONSTANT   ;

FORTH VARIABLE DEFER-LIST-T META

: DEFER   ( -- )
        TARGET-CREATE  [TARGET] DODEFER 
        0 ,-T
        HERE-T  DEFER-LIST-T @ ,-T  DEFER-LIST-T !
        0 ,-T  ;

FORWARD: <(;CODE)>
FORWARD: <DODOES>

T: ;CODE ( -- addr )
       =CALL C,-T [FORWARD] <(;CODE)>   
       STATE-T OFF   IN-META
       INIT-ASSEMBLER T;

T: DOES> ( -- addr )
       =CALL C,-T [FORWARD] <(;CODE)>   
       =CALL C,-T [FORWARD] <DODOES> T;

\ FORWARD: <;>
FORWARD: <?RX2>
FORWARD: <RX2>
FORWARD: <TX!2>
FORWARD: <!IO2>
FORWARD: <BYE2>
FORWARD: <LOCKDLLS>
FORWARD: <LOCKAPIS>
FORWARD: <INIT-FLOAD-BUFFER>
\ FORWARD: <WINDOWDEMO>
\ T: ;      =CALL C,-T  [FORWARD]  <;>  T;
T: ?RX2   =CALL C,-T  [FORWARD]  <?RX2>  T;
T: RX2    =CALL C,-T  [FORWARD]  <RX2>   T;
T: TX!2   =CALL C,-T  [FORWARD]  <TX!2>  T;
T: !IO2   =CALL C,-T  [FORWARD]  <!IO2>  T;
T: BYE2   =CALL C,-T  [FORWARD]  <BYE2>  T;
T: LOCKDLLS =CALL C,-T  [FORWARD]  <LOCKDLLS>  T;
T: LOCKAPIS =CALL C,-T  [FORWARD]  <LOCKAPIS>  T;
T: INIT-FLOAD-BUFFER =CALL C,-T  [FORWARD]  <INIT-FLOAD-BUFFER>  T;
\ T: WINDOWDEMO =CALL C,-T  [FORWARD]  <WINDOWDEMO>  T;

( Identify numbers single numbers only )

: NUMBER?  ( addr len -- n f )
        OVER C@ [CHAR] - =              \ leading minus sign?
        DUP >R IF  1 /STRING  THEN
        0 0 2SWAP >NUMBER 0= NIP NIP  ( -- u f )
        R> IF SWAP NEGATE SWAP THEN ;

( Meta Compiler Compiling Loop. )

FORTH VARIABLE T-IN META
: TOKEN  ( -- addr )
        BEGIN   >IN @ T-IN !
                BL WORD  DUP C@ 0=
        WHILE   DROP REFILL  0= ABORT" end of file in definition"
        REPEAT  ?UPPERCASE ;

: ]   ( -- )
        STATE-T ON  IN-TRANSITION 
        BEGIN   IN-TRANSITION
                TOKEN FIND
                IF      EXECUTE
                ELSE    COUNT NUMBER?
                        IF      [TRANSITION] LITERAL 
                        ELSE    ." Test Point" CR
                                DROP T-IN @ >IN !
                                UNDEFINED ( create forward reference )
                        THEN
                THEN
                STATE-T @ 0=
        UNTIL   ;

T: [   IN-META   STATE-T OFF   T;
T: ;   [TARGET] EXIT [TRANSITION] [   T;

( Interpretive words for Meta )
: forth@ @ ;
: @            @-T ; 
: !            !-T ; 
: '            'T >BODY forth@ ;
: ,           ,-T ;
: W,         W,-T ;
: C,         C,-T ;
: HERE     HERE-T ;
: ALLOT   ALLOT-T ;
: ,"    STRING,-T ;
: >BODY   >BODY-T ;
: +  + ;
: CELL+ CELL+ ;
: CELL- CELL- ;
: DUP DUP ; 		

: :   TARGET-CREATE ] ;

( Include HenceForth Kernel Definitions )
FLOAD HF2KRNL.F
 
( Include HenceForth Advanced WIN32 Definitions )
FLOAD HF3AWIN.F

( Include HenceForth Extension Definitions )
FLOAD HF4EXT.F

( Include HenceForth DEMO Definitions )
FLOAD HF5DEMO.F

( Resolve metacompiler forward references )
' ."|           RESOLVES <(.")>
' _abort"       RESOLVES <(ABORT")>
' doVOC         RESOLVES <VOCABULARY> 
\ ' ;             RESOLVES <;> 
' ?RX2          RESOLVES <?RX2>
' RX2           RESOLVES <RX2>
' TX!2          RESOLVES <TX!2> 
' !IO2		RESOLVES <!IO2>
' BYE2          RESOLVES <BYE2> 
' LOCKDLLS      RESOLVES <LOCKDLLS>
' LOCKAPIS      RESOLVES <LOCKAPIS>
' INIT-FLOAD-BUFFER RESOLVES <INIT-FLOAD-BUFFER>
\ ' WINDOWDEMO    RESOLVES <WINDOWDEMO>
' (;CODE)	RESOLVES <(;CODE)>
' doDOES	RESOLvES <DODOES>


( Initialize User Variables )

=SPP         SP0         ROM_USER + !  \ (SP0)      Pointer to bottom of the data stack.
\ =RPP         RP0         ROM_USER + !  \ (RP0)      Pointer to bottom of the return stack.
' ?RX        '?KEY       ROM_USER + !  \ ('?KEY)    Execution vector of ?KEY.
' TX!        'EMIT       ROM_USER + !  \ ('EMIT)    Execution vector of EMIT.
' accept     'EXPECT     ROM_USER + !  \ ('EXPECT)  Execution vector of EXPECT.
' kTAP       'TAP        ROM_USER + !  \ ('TAP)     Execution vector of TAP.
' TX!        'ECHO       ROM_USER + !  \ ('ECHO)    Execution vector of ECHO.
' .OK        'PROMPT     ROM_USER + !  \ ('PROMPT)  Execution vector of PROMPT.
=BASEE       BASE        ROM_USER + !  \ (BASE)     Storage of the radix base for numeric I/O.
                                       \ (tmp)      A temporary storage location used in parse and find.
                                       \ (SPAN)     Hold character count received by EXPECT.
                                       \ (>IN)      Hold the character pointer while parsing input stream.
                                       \ (#TIB)     Hold the current count. 
=TIB         #TIB CELL+  ROM_USER + !  \            Pointer to TIB 
                                       \ (CSP)      Hold the stack pointer for error checking.
' $INTERPRET 'EVAL       ROM_USER + !  \ ('EVAL)    Execution vector of EVAL.
' NUMBER?    'NUMBER     ROM_USER + !  \ ('NUMBER)  Execution vector of NUMBER?.
                                       \ (HLD)      Hold a pointer in building a numeric output string.
                                       \ (HANDLER)  Hold the return stack pointer for error handling.
                                       \ (CONTEXTA) Area to specify vocabulary search order.
                                       \            Vocabulary stack 
                                       \ (CURRENT)  Point to the vocabulary to be extended.
                                       \            vocabulary link pointer
CP-T forth@  CP          ROM_USER + !  \ (CP)       Point to the top of the code dictionary.
NP-T forth@  NP          ROM_USER + !  \ (NP)       Point to the bottom of the name dictionary.
LAST-T forth@ LAST       ROM_USER + !  \ (LAST)     Point to the last name in the name dictionary.

( System Initial Area )

' COLD FORTH CONSTANT <COLD> META


HERE
INIT_BASE ORG 
LABEL _init
 mov  	SP, # =SPP
 jmp    <COLD>
END-CODE 
ORG

( Final Check )
META

CR .( Unresolved references: ) CR   .UNRESOLVED
5 pause-seconds


( **************************** The Latest Steo ***************************** ) 
( Go back to FORTH with META's stuff )
IN-FORTH

( Win32 PE Header Defintion )
: 4TOW,  ( n1 n2 n3 n4 -- n )
  18 LSHIFT
  SWAP 10 LSHIFT OR
  SWAP 08 LSHIFT OR
  SWAP OR , ;

: 2TOW,  ( n1 n2 -- n )
  10 LSHIFT
  SWAP OR , ;

: CODE_SIZE ( -- n )
  HERE-T MEM_BASE - FREE_SIZE + ;

\ DOS-Stub Defintion (RVA:0000)($40 bytes)
40 CONSTANT STUB_SIZE
CREATE DOS_STUB
CHAR M CHAR Z 00 00 4TOW,               \ (00) 'M','Z', 0, 0 
00 , 00 , 00 , 00 , 00 , 00 , 00 ,      \ (04~1C) 28 bytes are all 0
00 , 00 , 00 , 00 , 00 , 00 , 00 ,      \ (20~38) 28 bytes are all 0
40 00 00 00 4TOW,                       \ (3C) (PE File Offset)

\ PE Header Defintion
3C0 CONSTANT HEADER_SIZE 
CREATE PE_HEADER
\ PE signature (RVA:0040)($4 bytes)
CHAR P CHAR E 00 00 4TOW,               \ (00) 'P','E',0,0 (SIGNATURE BYTES)
\ File header (RVA:0044)($14 bytes)
4C 01 01 00 4TOW,                       \ (04) $14C (MACHINE), $0001 (NumberOfSection)
00 00 00 00 4TOW,                       \ (08) $00000000 (TimeDataStamp)
00 00 00 00 4TOW,                       \ (0C) $00000000 (PointerToSymbolTable)
00 00 00 00 4TOW,                       \ (10) $00000000 (NumberOfSymbols)  
E0 00 02 01 4TOW,                       \ (14) $00E0 (SizeOfOptionalHeader), *****important*****
                                        \      $0102 (Characteristices)
\ Optional header (RVA:0058)($60 bytes)
0B 01 00 00 4TOW,                       \ (18) $010B (Magic), 
                                        \      $00 (MajorLinkerVersion), 
                                        \      $00 (MinorLinkerVersion)
CODE_SIZE $200 + ,     			\ (1C) $???????? (SizeOfCode) <=*****
00 00 00 00 4TOW,                       \ (20) $00000000 (SizeOfInitializedData) <=*****
00 00 00 00 4TOW,                       \ (24) $00000000 (SizeOfUninitializedData) <=*****
ASSEMBLER _init FORTH PE_BASE - ,       \ (28) $???????? (AddressOfEntryPoint) <=*****
00 10 00 00 4TOW,                       \ (2C) $00001000 (BaseOfCode) <=*****
00 00 00 00 4TOW,                       \ (30) $00000000 (BaseOfData) <=*****
00 00 40 00 4TOW,                       \ (34) $00400000 (ImageBase)
00 10 00 00 4TOW,                       \ (38) $00001000 (SectionAligment)
00 02 00 00 4TOW,                       \ (3C) $00000200 (FileAligment)
04 00 00 00 4TOW,                       \ (40) $0004 (MajorOperationSystemVersion),
                                        \      $0000 (MinorOperationSystemVersion)
00 00 00 00 4TOW,                       \ (44) $0000 (MajorImageVersion),
                                        \      $0000 (MinorImageVersion)
04 00 00 00 4TOW,                       \ (48) $0004 (MajorSubsystemVersion),
                                        \      $0000 (MinorSubsystemVersion)
00 00 00 00 4TOW,                 	\ (4C) $00000000 (Win32VersionValue)
1200 CODE_SIZE + 1000 / 1 + 1000 * ,   	\ (50) $???????? (SizeOfImage) <=*****
00 02 00 00 4TOW,                       \ (54) $00000200 (SizeOfHeader) <=*****
00 00 00 00 4TOW,                       \ (58) $00000000 (CheckSum)
02 00 00 00 4TOW,                       \ (5C) $0002 (Subsystem -- Win32 GUI)
                                        \      $0000 (DllCharacteristics)
00 00 10 00 4TOW,                       \ (60) $00100000 (SizeOfStackReserve)
00 10 00 00 4TOW,                       \ (64) $00001000 (SizeOfStackCommit)
00 00 10 00 4TOW,                       \ (68) $00100000 (SizeOfHeapReserve)
00 10 00 00 4TOW,                       \ (6C) $00001000 (SizeOfHeapCommit)
00 00 00 00 4TOW,                       \ (70) $00000000 (LoaderFlags)
10 00 00 00 4TOW,                       \ (74) $00000010 (NumberOfRvaAndSize)
\ Data Diectory (RVA:00B8)($80 bytes)
00 , 00 ,                               \ (00) $00000000 (IMAGE_DIRECTORY_ENTRY_EXPORT)
00001000 , 00000028 ,                   \ (08) $00000000 (IMAGE_DIRECTORY_ENTRY_IMPORT) <=*****
\ 00 , 00 ,                   		\ (10) $00000000 (IMAGE_DIRECTORY_ENTRY_RESOURCE)
00001080 , 00000164 ,                   \ (10) $00000000 (IMAGE_DIRECTORY_ENTRY_RESOURCE)
00 , 00 ,                               \ (18) $00000000 (IMAGE_DIRECTORY_ENTRY_EXCEPTION)
00 , 00 ,                               \ (20) $00000000 (IMAGE_DIRECTORY_ENTRY_SECUIRITY)
00 , 00 ,                               \ (28) $00000000 (IMAGE_DIRECTORY_ENTRY_BASERELOC)
00 , 00 ,                               \ (30) $00000000 (IMAGE_DIRECTORY_ENTRY_DEBUG)
00 , 00 ,                               \ (38) $00000000 (IMAGE_DIRECTORY_ENTRY_COPYRIGHT)
00 , 00 ,                               \ (40) $00000000 (IMAGE_DIRECTORY_ENTRY_GLOBALPTR)
00 , 00 ,                               \ (48) $00000000 (IMAGE_DIRECTORY_ENTRY_TLS)
00 , 00 ,                               \ (50) $00000000 (IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG)
00 , 00 ,                               \ (58) $00000000 (IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT)
00 , 00 ,                               \ (60) $00000000 (IMAGE_DIRECTORY_ENTRY_IAT)
00 , 00 ,                               \ (68) 
00 , 00 ,                               \ (70) 
00 , 00 ,                               \ (78) 
\ Section Header -- Code (RVA:0138)($28 bytes)
2E 74 65 78 4TOW,                       \ (00) ".tex" (NAME)
74 00 00 00 4TOW,                       \      't' 0, 0, 0,
00 00 00 00 4TOW,                       \ (08) $00000000 (VirtualSize)
00 10 00 00 4TOW,                       \ (0C) $00001000 (VirtualAddress) <=*****
CODE_SIZE $200 + ,                      \ (10) $???????? (SizeOfRawData) <=*****
00 02 00 00 4TOW,                       \ (14) $00000200 (PointerToRawData) <=*****
00 00 00 00 4TOW,                       \ (18) $00000000 (PointerToReLocations)
00 00 00 00 4TOW,                       \ (1C) $00000000 (PointerToLineNumbers)
00 00 00 00 4TOW,                       \ (20) $0000 (NumberOfRelocations)
                                        \      $0000 (NumberOfLineNumbers)
20 00 00 E0 4TOW,                       \ (24) $E0000020 (Characteristics) <=*****
\ Padding Bytes (RVA:0160)($A0 bytes)=> total is $200 bytes
00 , 00 , 00 , 00 ,                     \ (00) 16 Bytes 0
00 , 00 , 00 , 00 ,                     \ (10) 16 Bytes 0
00 , 00 , 00 , 00 ,                     \ (20) 16 Bytes 0
00 , 00 , 00 , 00 ,                     \ (30) 16 Bytes 0
00 , 00 , 00 , 00 ,                     \ (40) 16 Bytes 0
00 , 00 , 00 , 00 ,                     \ (50) 16 Bytes 0
00 , 00 , 00 , 00 ,                     \ (60) 16 Bytes 0
00 , 00 , 00 , 00 ,                     \ (70) 16 Bytes 0
00 , 00 , 00 , 00 ,                     \ (80) 16 Bytes 0
00 , 00 , 00 , 00 ,                     \ (90) 16 Bytes 0

\ IMAGE_IMPORT_DESCRIPTOR#1 (RVA:1000)($14 bytes)
44 10 00 00 4TOW,       		\ OriginalFirstThunk
00 00 00 00 4TOW,                       \ TimeDateStamp
FF FF FF FF 4TOW,                       \ ForwarderChain
28 10 00 00 4TOW,                       \ Name
38 10 00 00 4TOW,                       \ FirstThunk
\ IMAGE_IMPORT_DESCRIPTOR_TERMINATOR (RVA:1014)($14 bytes)
00 00 00 00 4TOW,       		\ OriginalFirstThunk
00 00 00 00 4TOW,                       \ TimeDateStamp
00 00 00 00 4TOW,                       \ ForwarderChain
00 00 00 00 4TOW,                       \ Name
00 00 00 00 4TOW,                       \ FirstThunk
\ DLL Name (RVA:1028)($10 bytes)
CHAR K CHAR E CHAR R CHAR N 4TOW,       \ "KERNEL32.dll" 
CHAR E CHAR L CHAR 3 CHAR 2 4TOW,
CHAR . CHAR d CHAR l CHAR l 4TOW,
00 00 00 00 4TOW,                       \ 0, Padding 0 
\ First Thunk (RVA:1038)($C bytes)
50 10 00 00 4TOW,           		\ AddressOfData
60 10 00 00 4TOW,           		\ AddressOfData
00 00 00 00 4TOW,           		\ terminator
\ Original First Thunk (RVA:1044)($C bytes)
50 10 00 00 4TOW,           		\ AddressOfData
60 10 00 00 4TOW,           		\ AddressOfData
00 00 00 00 4TOW,           		\ terminator
\ IMAGE_IMPORT_BY_NAME (RVA:1050)($10 bytes)
00 00 CHAR L CHAR o 4TOW,               \ Ordinal
CHAR a CHAR d CHAR L CHAR i 4TOW,       \ "LoadLibraryA"
CHAR b CHAR r CHAR a CHAR r 4TOW,
CHAR y CHAR A 0 0 4TOW,                        
\ IMAGE_IMPORT_BY_NAME (RVA:1060)($14 bytes)
00 00 CHAR G CHAR e 4TOW,               \ Ordinal
CHAR t CHAR P CHAR r CHAR o 4TOW,       \ "GetProcAddress"
CHAR c CHAR A CHAR d CHAR d 4TOW,
CHAR r CHAR e CHAR s CHAR s 4TOW,                        
0 0 0 0 4TOW,
\ Padding (RVA:1074)($8C bytes)=> resource start from RVA:1100
00 , 00 , 00 ,	    		        \ (74)

\ IMAGE_RESOURCE_DIRECTORY (RVA:1080)($A0 bytes)
00 00 00 00 4TOW,			\ (00) $00000000 (Characteristics) 
00 00 00 00 4TOW,	                \ (04) $00000000 (TimeDatwStamp)
00 00 00 00 4TOW,                       \ (08) $0000 (MajorVersion)
                                        \      $0000 (MinorVersion)
00 00 02 00 4TOW,                       \ (0C) $0000 (NumberOfNamedEntries)
 					\      $0002 (NumberOfIdEntries)
03 00 00 00 4TOW,                       \ (10) $00000003 (Id:Icon)
20 00 00 80 4TOW,                       \ (14) $80000020 (Offset)  <=*****
0E 00 00 00 4TOW,                       \ (18) $0000000E (Id:Group Icon)
38 00 00 80 4TOW,                       \ (1C) $80000038 (Offset)  <=*****

00 00 00 00 4TOW,			\ (20) $00000000 (Characteristics) 
00 00 00 00 4TOW,	                \ (24) $00000000 (TimeDatwStamp)
00 00 00 00 4TOW,                       \ (28) $0000 (MajorVersion)
                                        \      $0000 (MinorVersion)
00 00 01 00 4TOW,                       \ (2C) $0000 (NumberOfNamedEntries)
 					\      $0001 (NumberOfIdEntries)
01 00 00 00 4TOW,                       \ (30) $00000001 (Id)  
50 00 00 80 4TOW,                       \ (34) $80000050 (Offset) <=*****

00 00 00 00 4TOW,			\ (38) $00000000 (Characteristics) 
00 00 00 00 4TOW,	                \ (3C) $00000000 (TimeDatwStamp)
00 00 00 00 4TOW,                       \ (40) $0000 (MajorVersion)
                                        \      $0000 (MinorVersion)
00 00 01 00 4TOW,                       \ (44) $0000 (NumberOfNamedEntries)
 					\      $0001 (NumberOfIdEntries)
01 00 00 00 4TOW,                       \ (48) $00000001 (Id)  
68 00 00 80 4TOW,                       \ (4C) $80000068 (Offset) <=*****

00 00 00 00 4TOW,			\ (50) $00000000 (Characteristics) 
00 00 00 00 4TOW,	                \ (54) $00000000 (TimeDatwStamp)
00 00 00 00 4TOW,                       \ (58) $0000 (MajorVersion)
                                        \      $0000 (MinorVersion)
00 00 01 00 4TOW,                       \ (5C) $0000 (NumberOfNamedEntries)
 					\      $0001 (NumberOfIdEntries)
01 00 00 00 4TOW,                       \ (60) $00000001 (Id)  
80 00 00 00 4TOW,                       \ (64) $00000090 (Offset) <=*****

00 00 00 00 4TOW,			\ (68) $00000000 (Characteristics) 
00 00 00 00 4TOW,	                \ (6C) $00000000 (TimeDatwStamp)
00 00 00 00 4TOW,                       \ (70) $0000 (MajorVersion)
                                        \      $0000 (MinorVersion)
00 00 01 00 4TOW,                       \ (74) $0000 (NumberOfNamedEntries)
 					\      $0001 (NumberOfIdEntries)
01 00 00 00 4TOW,                       \ (78) $00000001 (Id)  
90 00 00 00 4TOW,                       \ (7C) $000000A0 (Offset) <=*****

20 11 00 00 4TOW,                       \ (80) $00001120 (RVA) <=*****
B0 00 00 00 4TOW,                       \ (84) $000000B0 (Size)
00 00 00 00 4TOW,                       \ (88) $00000000 (Codepage)
00 00 00 00 4TOW,                       \ (8C) $00000000 (Unused)

D0 11 00 00 4TOW,                       \ (90) $000011D0 (RVA)
14 00 00 00 4TOW,                       \ (94) $00000014 (Size)
00 00 00 00 4TOW,                       \ (98) $00000000 (Codepage)
00 00 00 00 4TOW,                       \ (9C) $00000000 (Unused)
\ BMP InfoHeader (RVA:1120)($28 bytes)
28 00 00 00 4TOW,                       \ (A0) $00000028 (Size)
10 00 00 00 4TOW,                       \ (A4) $00000010 (Width)
20 00 00 00 4TOW,                       \ (A8) $00000020 (Height)
01 00 01 00 4TOW,                       \ (AC) $0001 (Plans), $0001 (BitCount)
00 00 00 00 4TOW,                       \ (B0) $00000000 (Compression)
80 00 00 00 4TOW,                       \ (B4) $00000080 (ImageSize)
00 00 00 00 4TOW,                       \ (B8) $00000000 (XpixelsPerM)
00 00 00 00 4TOW,                       \ (BC) $00000000 (YpixelsPerM)
00 00 00 00 4TOW,                       \ (C0) $00000000 (ColorsUsed)
00 00 00 00 4TOW,                       \ (C4) $00000000 (ColorsImportant)
\ BMP Platte  (RVA:1148)($8 bytes)
00 00 00 00 4TOW,                       \ (C8) $00000000 (Color#1)
FF FF FF 00 4TOW,                       \ (CC) $00FFFFFF (Color#2) 
\ XorMap (RVA:1150)($40 bytes)
80 C, 01 C, 00 C, 00 C, 71 C, C0 C, 00 C, 00 C,			
71 C, C0 C, 00 C, 00 C, 71 C, C0 C, 00 C, 00 C,
71 C, C0 C, 00 C, 00 C, 71 C, C0 C, 00 C, 00 C,
7F C, FE C, 00 C, 00 C, 7F C, FE C, 00 C, 00 C,
7F C, FE C, 00 C, 00 C, 71 C, C0 C, 00 C, 00 C,
71 C, C0 C, 00 C, 00 C, 71 C, C0 C, 00 C, 00 C,
71 C, FE C, 00 C, 00 C, 71 C, FE C, 00 C, 00 C,
71 C, FE C, 00 C, 00 C, 80 C, 01 C, 00 C, 00 C,
\ AndMap (RVA:1190)($40 bytes)
00 C, 00 C, 00 C, 00 C, 00 C, 00 C, 00 C, 00 C,
00 C, 00 C, 00 C, 00 C, 00 C, 00 C, 00 C, 00 C,
00 C, 00 C, 00 C, 00 C, 00 C, 00 C, 00 C, 00 C,
00 C, 00 C, 00 C, 00 C, 00 C, 00 C, 00 C, 00 C,
00 C, 00 C, 00 C, 00 C, 00 C, 00 C, 00 C, 00 C,
00 C, 00 C, 00 C, 00 C, 00 C, 00 C, 00 C, 00 C,
00 C, 00 C, 00 C, 00 C, 00 C, 00 C, 00 C, 00 C,
00 C, 00 C, 00 C, 00 C, 00 C, 00 C, 00 C, 00 C,
\ Group-Icon data (RVA:11D0)($14 bytes)
00 00 01 00 4TOW,	\ (D0) $0000 (idReserved), $0001 (idType) 			
01 00 10 10 4TOW,       \ (D4) $0001 (idCount), $10 (bWidth), $10 (bHeight)        
02 00 01 00 4TOW,       \ (D8) $02 (bColorCount), $00 (bReserved), $0001 (wPlanes) 
01 00 B0 00 4TOW,       \ (DC) $0001 (wBitCount), $000000B0 (dwBytesInRes)          
00 00 01 00 4TOW,       \ (E0) $0001 (nID)

\ Padding (RVA:11E4)($1C bytes)=> code start from RVA:1200
00 , 00 , 00 ,	    		        \ (E4)
00 , 00 , 00 , 00 , 			\ (F0)
       
VARIABLE FILE_HANDLE
: WRITE_PE_FILE
  S" HF.EXE" R/W CREATE-FILE
  ABORT" Create file error."
  FILE_HANDLE !
  DOS_STUB STUB_SIZE FILE_HANDLE @ WRITE-FILE
  ABORT" Write file error."
  PE_HEADER HEADER_SIZE FILE_HANDLE @ WRITE-FILE
  ABORT" Write file error."
  IMAGE CODE_SIZE FILE_HANDLE @ WRITE-FILE
  ABORT" Write file error."  
  FILE_HANDLE @ CLOSE-FILE
  ABORT" Close file error."
  ;

CR .( Write to a PE file: HE.exe ) CR                 
WRITE_PE_FILE

