\ Copyright (c) 2002 by Wuja
\ All rights reserved 
\
\ HFEXT.F   18MAY02 created by Wuja.
\
\ HenceForth Extension Definition.
\
\ Description:
\     This is my first time to port Dr. Ting's eForth system to the Win32 environment.
\   It is also my first time to have so much interest in the MS Windows programming.
\   Before this, of couse, I have some knowledge about how to program a Widowns program.
\   But I didn't have any idea to connect the two world between the Forth and the Windows.
\   Thank Yap's WeForth for giving me so perfect experience about eForth's first step in 
\   the Windows. Based on it, then I can get enough encouragement to try my first step. 
\
\ Version Hsiroty: 
\ V0.1,    18MAY02WUJA,  o Build DOES> relative definition.
\                        o Build the essential Windows API definitions.
\ V0.2,    25MAY02WUJA,  o Remove the essential Windows API definitions.
\ V0.3,    31MAY02WUJA,  o Add file relative definitions.
\ V0.4,    02JUN02WUJA,  o Add console IO relative definitions.
\ V0.5,    02JUN02WUJA,  o Add basic FLOAD relative definitions.
\ 

\ DOES> relative definitions.
: (;CODE) ( -- )                        \ Modify execute behavior of last word as one following (;CODE)
  R> LAST @ NAME> 1 + SWAP OVER CELL+ - SWAP ! ; 

: doDOES ( -- a )			\ run-time code of DOSE> 
  R> R> SWAP >R ;  COMPILE-ONLY
  
: DOES> ( -- )				\ define run-time code
  COMPILE (;CODE) COMPILE doDOES ; IMMEDIATE 

\ Console IO definitions
CREATE MSVCRT 				\ Make a MSVCRT DLL structure manually
HERE 0 , 0 , 0 , DLL-LINK DUP @ , !
HERE 					\ Build string address manually
CHAR M C, CHAR S C, CHAR V C, CHAR C C,
CHAR R C, CHAR T C, CHAR . C, CHAR d C,
CHAR l C, CHAR l C, 0 C,
MSVCRT CELL+ !                         

CREATE KERNEL32 			\ Make a KERNEL32 DLL structure manually
HERE 0 , 0 , 0 , DLL-LINK DUP @ , !
HERE 					\ Build string address manually
CHAR K C, CHAR E C, CHAR R C, CHAR N C,
CHAR E C, CHAR L C, CHAR 3 C, CHAR 2 C,
CHAR . C, CHAR d C, CHAR l C, CHAR l C,
0 C,
KERNEL32 CELL+ !                         

CREATE _kbhit				\ Make a _kbhit API structure manually
HERE 0 , 0 , 0 , MSVCRT , API-LINK DUP @ , !
HERE ' _kbhit ORG			\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR _ C, CHAR k C, CHAR b C, CHAR h C,
CHAR i C, CHAR t C, 0 C,
_kbhit CELL+ !                         

CREATE _getch				\ Make a _getch API structure manually
HERE 0 , 0 , 0 , MSVCRT , API-LINK DUP @ , !
HERE ' _getch ORG			\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR _ C, CHAR g C, CHAR e C, CHAR t C, 
CHAR c C, CHAR h C, 0 C,
_getch CELL+ !                         

CREATE _putch				\ Make a _putch API structure manually
HERE 0 , 0 , 0 , MSVCRT , API-LINK DUP @ , !
HERE ' _putch ORG			\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR _ C, CHAR p C, CHAR u C, CHAR t C, 
CHAR c C, CHAR h C, 0 C,
_putch CELL+ !                         

CREATE _exit				\ Make a _exit API structure manually
HERE 0 , 0 , 0 , MSVCRT , API-LINK DUP @ , !
HERE ' _exit ORG			\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR _ C, CHAR e C, CHAR x C, CHAR i C,
CHAR t C, 0 C,
_exit CELL+ !                         

CREATE AllocConsole			\ Make a AllocConsole API structure manually
HERE 0 , 0 , 0 , KERNEL32 , API-LINK DUP @ , !
HERE ' AllocConsole ORG			\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR A C, CHAR l C, CHAR l C, CHAR o C,
CHAR c C, CHAR C C, CHAR o C, CHAR n C,
CHAR s C, CHAR o C, CHAR l C, CHAR e C,
0 C,
AllocConsole CELL+ !                         

: BYE2
  1 >R  0 >R _exit ;
  
: ?RX2 ( -- c T | F )
  _kbhit Return@
  IF
    _getch Return@ -1
  ELSE
    0 
  THEN ;
  
: RX2 ( -- c )
  _getch Return@ ; 

: TX!2 ( c -- )
  >R _putch R> DROP ;
   
: !IO2 ( -- )
  AllocConsole ;

\ Memory operation relative definitions.
CREATE VirtualAlloc			\ Make a VirtualAlloc API structure manually
HERE 0 , 0 , 0 , KERNEL32 , API-LINK DUP @ , !
HERE ' VirtualAlloc ORG			\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR V C, CHAR i C, CHAR r C, CHAR t C,
CHAR u C, CHAR a C, CHAR l C, CHAR A C,
CHAR l C, CHAR l C, CHAR o C, CHAR c C,
0 C,
VirtualAlloc CELL+ !           

: MALLOC ( n -- a )
  4 >R					\ PAGE_READWRITE
  1000 >R				\ MEM_COMMIT
  >R					\ size
  0 >R					\ NULL 
  VirtualAlloc Return@
  ;
  
\ File operation relative definitions.

\ HANDLE CreateFile(
\   LPCTSTR lpFileName,                         // file name
\   DWORD dwDesiredAccess,                      // access mode
\   DWORD dwShareMode,                          // share mode
\   LPSECURITY_ATTRIBUTES lpSecurityAttributes, // SD
\   DWORD dwCreationDisposition,                // how to create
\   DWORD dwFlagsAndAttributes,                 // file attributes
\   HANDLE hTemplateFile                        // handle to template file
\ );


CREATE OPENFILENAME   100 ALLOT

CREATE OFN   13 CELLS ALLOT

\ OFN structure in C syntax
\ typedef struct tagOFN { // ofn 
\    DWORD         lStructSize;      
\    HWND          hwndOwner;        
\    HINSTANCE     hInstance;        
\    LPCTSTR       lpstrFilter;      
\    LPTSTR        lpstrCustomFilter;
\    DWORD         nMaxCustFilter;   
\    DWORD         nFilterIndex;     
\    LPTSTR        lpstrFile;        
\    DWORD         nMaxFile;         
\    LPTSTR        lpstrFileTitle;   
\    DWORD         nMaxFileTitle;    
\    LPCTSTR       lpstrInitialDir;  
\    LPCTSTR       lpstrTitle;       
\    DWORD         Flags;            
\    WORD          nFileOffset;      
\    WORD          nFileExtension;   
\    LPCTSTR       lpstrDefExt;      
\    DWORD         lCustData;        
\    LPOFNHOOKPROC lpfnHook;         
\    LPCTSTR       lpTemplateName;   
\ } OPENFILENAME; 

4C OFN !		\ lStructSize = 80 bytes
0  OFN 1 CELLS + ! 	\ hwndOwner = NULL
OPENFILENAME
   OFN 7 CELLS + !      \ lpstrFile = OPENFILENAME  
FF OFN 8 CELLS + !      \ nMaxFile = 255 bytes
00000004		\ OFN_HIDEREADONLY
00000800 OR		\ OFN_PATHMUSTEXIST            
00001000 OR		\ OFN_FILEMUSTEXIST            
00080000 OR		\ OFN_EXPLORER
00200000 OR		\ OFN_LONGNAMES
   OFN D CELLS + !      \ set Flags 

CREATE COMDLG32 			\ Make a COMDLG32 DLL structure manually
HERE 0 , 0 , 0 , DLL-LINK DUP @ , !
HERE 					\ Build string address manually
CHAR C C, CHAR O C, CHAR M C, CHAR D C,
CHAR L C, CHAR G C, CHAR 3 C, CHAR 2 C, 
CHAR . C, CHAR d C, CHAR l C, CHAR l C,
0 C,
COMDLG32 CELL+ !                         

CREATE GetOpenFileNameA			\ Make a GetOpenFileNameA API structure manually
HERE 0 , 0 , 0 , COMDLG32 , API-LINK DUP @ , !
HERE ' GetOpenFileNameA ORG		\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR G C, CHAR e C, CHAR t C, CHAR O C,
CHAR p C, CHAR e C, CHAR n C, CHAR F C,
CHAR i C, CHAR l C, CHAR e C, CHAR N C,
CHAR a C, CHAR m C, CHAR e C, CHAR A C,
0 C,
GetOpenFileNameA CELL+ !                         

CREATE CreateFileA			\ Make a CreateFileA API structure manually
HERE 0 , 0 , 0 , KERNEL32 , API-LINK DUP @ , !
HERE ' CreateFileA ORG			\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR C C, CHAR r C, CHAR e C, CHAR a C,
CHAR t C, CHAR e C, CHAR F C, CHAR i C,
CHAR l C, CHAR e C, CHAR A C, 0 C,
CreateFileA CELL+ !           

CREATE GetFileSize			\ Make a GetFileSize API structure manually
HERE 0 , 0 , 0 , KERNEL32 , API-LINK DUP @ , !
HERE ' GetFileSize ORG			\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR G C, CHAR e C, CHAR t C, CHAR F C,
CHAR i C, CHAR l C, CHAR e C, CHAR S C,
CHAR i C, CHAR z C, CHAR e C, 0 C,
GetFileSize CELL+ !           

CREATE ReadFile				\ Make a ReadFile API structure manually
HERE 0 , 0 , 0 , KERNEL32 , API-LINK DUP @ , !
HERE ' ReadFile ORG			\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR R C, CHAR e C, CHAR a C, CHAR d C,
CHAR F C, CHAR i C, CHAR l C, CHAR eS C,
0 C,
ReadFile CELL+ !           

CREATE CloseHandle			\ Make a CloseHandle API structure manually
HERE 0 , 0 , 0 , KERNEL32 , API-LINK DUP @ , !
HERE ' CloseHandle ORG			\ Change the API run time code to doAPI
ASSEMBLER doAPI IN-META CALL, ORG
HERE 					\ Build string address manually
CHAR C C, CHAR l C, CHAR o C, CHAR s C,
CHAR e C, CHAR H C, CHAR a C, CHAR n C,
CHAR d C, CHAR l C, CHAR e C, 0 C,
CloseHandle CELL+ !           

: FOPEN ( -<string>- n )
  0 >R					\ NULL
  20 >R					\ FILE_ATTRIBUTE_ARCHIVE
  3 >R					\ OPEN_EXISTING
  0 >R					\ NULL
  1 >R					\ FILE_SHARE_READ
  80000000 				\ GENERIC_READ
  40000000 OR >R			\ GENERIC_WRITE                        
  BL WORD 1 + >R			\ file name string address
  CreateFileA Return@                   \ open the file and get handle
  ;

: FSIZE ( n -- n )
  0 >R					\ don't care high order dword of file size
  >R GetFileSize Return@		\ get file size
  ;

VARIABLE READSIZE
: FREAD ( n1 a n2 -- n )
  0 >R					\ NULL
  READSIZE >R				\ file size read
  >R					\ file size to read
  >R					\ buffer address
  >R					\ file handle
  ReadFile Return@
  ;

: FCLOSE ( n -- n )
  >R CloseHandle Return@		\ close file
  ;

VARIABLE FLOAD-BUFFER
: INIT-FLOAD-BUFFER ( -- )
  100000 MALLOC
  ?DUP IF
    FLOAD-BUFFER !
  ELSE
    CR ." Alloc FLOAD buffer error." CR
  THEN 
  ;     

: FLOAD ( -<string>- n )
  FLOAD-BUFFER @ 0 = 
  IF CR ." No FLOAD buffer available." CR 0 EXIT THEN
  FOPEN
  DUP -1 = 
    IF CR ." Open file error." CR 
       DROP 0 EXIT
    THEN 
  DUP     				 
  FSIZE DUP 100000 U< NOT
    IF CR ." File size is too large to load." CR
       2DROP 0 EXIT 
    THEN
  >R DUP FLOAD-BUFFER @ R>
  FREAD 0 =
  IF CR ." Read file error." CR
    DROP 0 EXIT 
  THEN
  FCLOSE 1
  READSIZE @ #TIB !			\ reset TIB#
  FLOAD-BUFFER @ #TIB CELL+ !		\ reset TIB
  0 >IN !				\ reset >IN
  [ ' EVAL ] LITERAL CATCH ?DUP
  IF 
    NULL$ OVER XOR
    IF SPACE COUNT TYPE ." ?" THEN
    PRESET EXIT
  ELSE
    PRESET  
  THEN  
  ;   

  



  
  
  

              
  
  


